﻿
Public Class Form1

    ' ===================================================================================================
    '  OPEN CLOSE FORM
    ' ===================================================================================================
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ------------------------------------------------- 
        ShowWindowTitle()
        FillComboBoxModels(OllamaModelsFile)
        Load_INI()
        SetRichTextBoxFont(RTB, "Arial")
        RTB.ClearUndo()
        UpdateRunButton()
        ' ------------------------------------------------- 
        Timer20ms.Interval = 20
        Timer20ms.Start()
        EventsAreEnabled = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Timer20ms.Stop()
        Save_INI()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Friend Sub ShowWindowTitle()
        Text = AppTitleAndVersion()
    End Sub


    ' ===================================================================================
    '  Events accepting the first click
    ' ===================================================================================
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message.
    ' ===================================================================================
    <System.Diagnostics.DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' ===================================================================================
    '  RTB LINK CLICKED
    ' ===================================================================================
    Private Sub rtb_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkClickedEventArgs) Handles RTB.LinkClicked
        Process.Start(e.LinkText)
    End Sub


    ' ===================================================================================================
    '  REMOTE IP and SERVER
    ' ===================================================================================================
    Private Sub Button_InstallModel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_InstallModel.Click
        InstallModel(ComboBox_Model.Text)
        RTB.Focus()
    End Sub

    Private Sub Button_DeleteModel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DeleteModel.Click
        DeleteModel(ComboBox_Model.Text)
        RTB.Focus()
    End Sub

    Private Sub Button_ModelInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ModelInfo.Click
        ModelInfo(ComboBox_Model.Text)
        RTB.Focus()
    End Sub

    Private Sub Button_InstalledModels_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_InstalledModels.Click
        InstalledModels()
        RTB.Focus()
    End Sub

    Private Sub Button_Edit_Model_List_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Edit_Model_List.Click
        Process.Start("https://ollama.com/library")
        StartNotepadAndWait(OllamaModelsFile)
        FillComboBoxModels(OllamaModelsFile)
        RTB.Focus()
    End Sub

    Private Sub Button_DownloadOllama_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DownloadOllama.Click
        Process.Start("https://ollama.com/download/OllamaSetup.exe")
        RTB.Focus()
    End Sub

    Private OllamaModelsFile As String = "Theremino_Ollama_Models.txt"

    Private Sub StartNotepadAndWait(ByVal file As String)
        Dim p As Process = Process.Start(file)
        p.WaitForInputIdle()
        Do
            System.Threading.Thread.Sleep(100)
        Loop Until p.HasExited
    End Sub

    Private Sub FillComboBoxModels(ByVal file As String)
        If My.Computer.FileSystem.FileExists(file) Then
            Dim oldtext As String = ComboBox_Model.Text
            Dim items() As String = IO.File.ReadAllLines(file)
            ComboBox_Model.Items.Clear()
            For Each s As String In items
                ComboBox_Model.Items.Add(s)
            Next
            ComboBox_Model.Text = oldtext
            If ComboBox_Model.Text = "" Then ComboBox_Model.SelectedIndex = 0
        End If
    End Sub


    ' ===================================================================================================
    '  REMOTE IP and SERVER
    ' ===================================================================================================
    Private Sub TextBox_RemoteIP_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox_RemoteIP.DoubleClick
        Select Case TextBox_RemoteIP.Text
            Case "localhost" : TextBox_RemoteIP.Text = "192.168.0.2"
            Case "192.168.0.2" : TextBox_RemoteIP.Text = "192.168.0.3"
            Case "192.168.0.3" : TextBox_RemoteIP.Text = "192.168.0.148"
            Case Else : TextBox_RemoteIP.Text = "localhost"
        End Select
    End Sub

    Private Sub Button_StartServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_StartServer.Click
        StartOllamaServer()
        Dim s As String
        s = "Now the Ollama server is running on this computer." + vbCrLf + vbCrLf + _
            "To access this server from other devices:" + vbCrLf + _
            " - Leave the COM window open" + vbCrLf + _
            " - Use the IP of this computer, from the following list:" + vbCrLf + vbCrLf + _
            GetLocalIP()
        RTB_ReplaceText(s)
        RTB.Focus()
    End Sub


    ' ======================================================================================================
    '   REQUEST
    ' ======================================================================================================
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.MouseDown
        Ollama.Running = Not Ollama.Running
        UpdateRunButton()
        RTB.Focus()
    End Sub

    Private Sub btn_ClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClearAll.Click
        RTB_ReplaceText("")
        RTB.Focus()
    End Sub

    Private RandomPrompt As Int32 = 0
    Private Sub btm_Random_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btm_Random.Click
        Dim s As String
        RandomPrompt += 1
        Select Case RandomPrompt
            Case 2 : s = "Ciao come stai?"
            Case 3 : s = "Dammi l'elenco delle etnie umane."
            Case 4 : s = "Perché il gatto si gratta?"
            Case 5 : s = "Quanti abitanti ha Torino?"
            Case 6 : s = "Quanti abitanti ci sono in Cina?"
            Case 7 : s = "中国有多少居民？"
            Case Else : RandomPrompt = 1 : s = "Hello, how are you?"
        End Select
        RTB_ReplaceText(s)
        RTB.Focus()
    End Sub

    Friend Sub UpdateRunButton()
        If Ollama.Running Then
            Button1.BackColor = Color.FromArgb(240, 220, 140)
            Button1.Text = "STOP"
            Button1.Refresh()
            Ollama.SendPrompt(TextBox_RemoteIP.Text, ComboBox_Model.Text, RTB.Text)
            RTB.AppendText(vbCrLf + vbCrLf)
            RTB.Select()
        Else
            Button1.BackColor = Color.FromArgb(240, 255, 230)
            Button1.Text = "Send prompt"
            Ollama.StopAndCloseAll()
            RTB.Select()
        End If
    End Sub

    Friend Sub FlashRunButton()
        Static n As Int32
        If Ollama.WaitingResponse Then
            n += 1
            If n = 20 Then
                Button1.BackColor = Color.FromArgb(200, 240, 0)
            End If
            If n = 25 Then
                Button1.BackColor = Color.FromArgb(240, 220, 140)
                n = 0
            End If
        Else
            If n > 0 Then
                Button1.BackColor = Color.FromArgb(240, 220, 180)
                n = -1
            End If
        End If
    End Sub

    Private Sub TextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles RTB.KeyDown
        If My.Computer.Keyboard.CtrlKeyDown Then
            If e.KeyValue = 13 Then
                e.Handled = True
                Ollama.Running = True
                UpdateRunButton()
            End If
            'If e.KeyValue = Asc("???") Then ' DO NOT USE CTRL_C !
            '    e.Handled = True
            '    Ollama.Running = False
            '    UpdateRunButton()
            'End If
            'Debug.Print(e.KeyValue.ToString)
        End If
    End Sub

    Private Sub RTB_ReplaceText(ByVal str As String)
        RTB.SelectAll()
        RTB.SelectedText = str
    End Sub


    ' ===================================================================================================
    '  TIMER 1 
    ' ===================================================================================================
    Private Sub Timer20ms_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer20ms.Tick
        Ollama.ReadResponse()
        If Ollama.Running Then FlashRunButton()
    End Sub


    ' ======================================================================================================
    '   TEST AND DEBUG
    ' ======================================================================================================
    Private Sub TextBox1_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RTB.DoubleClick

    End Sub

    Private Sub Form1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.DoubleClick

    End Sub


End Class
