﻿
'Imports System.Runtime.InteropServices
'Imports System.Net.Sockets
'Imports System.Net
Imports System.Net.NetworkInformation

Module Module_NetFunctions

    ' ===============================================================================================
    '  SET OLLAMA SERVER
    ' ===============================================================================================
    Friend Sub StartOllamaServer()
        'SendCommandsToCMD("/k set OLLAMA_HOST=0.0.0.0:8080 & ollama serve")
        SendCommandsToCMD("/k set OLLAMA_HOST=0.0.0.0:11434 & ollama serve")
    End Sub

    Friend Sub InstallModel(ByVal model As String)
        SendCommandsToCMD("/k ollama run " + model)
    End Sub

    Friend Sub DeleteModel(ByVal model As String)
        SendCommandsToCMD("/k ollama rm " + model)
    End Sub

    Friend Sub ModelInfo(ByVal model As String)
        SendCommandsToCMD("/k ollama show " + model)
    End Sub

    Friend Sub InstalledModels()
        SendCommandsToCMD("/k ollama list")
    End Sub

    'Usage:
    '  ollama [flags]
    '  ollama [command]

    'Available Commands:
    '  serve       Start ollama
    '  create      Create a model from a Modelfile
    '  show        Show information for a model
    '  run         Run a model
    '  pull        Pull a model from a registry
    '  push        Push a model to a registry
    '  list        List models
    '  ps          List running models
    '  cp          Copy a model
    '  rm          Remove a model
    '  help        Help about any command

    'Flags:
    '  -h, --help      help for ollama
    '  -v, --version   Show version information

    'Use "ollama [command] --help" for more information about a command.


    ' ===============================================================================================
    '  SEND COMMAND TO CMD
    ' ===============================================================================================
    Private Sub SendCommandsToCMD(ByVal command As String)
        Dim proc As New Process
        Dim info As New ProcessStartInfo("cmd.exe")
        ' ------------------------------------------------------------------------
        info.Arguments = command ' + " & color f0"
        'info.UseShellExecute = False
        'info.RedirectStandardInput = True
        'info.RedirectStandardOutput = true
        ' -------------------------------------------------------------------------
        Try
            proc.StartInfo = info
            proc.Start()
        Catch ex As Exception
            MessageBox.Show("Error: " + ex.Message)
        End Try
    End Sub


    ' ===============================================================================================
    '  GET LOCAL IP 
    ' ===============================================================================================
    Friend Function GetLocalIP() As String
        Dim ip As String = ""
        For Each nic As NetworkInterface In NetworkInterface.GetAllNetworkInterfaces()
            For Each ipInfo As UnicastIPAddressInformation In nic.GetIPProperties.UnicastAddresses
                If ipInfo.Address.AddressFamily = Net.Sockets.AddressFamily.InterNetwork Then
                    If Not ipInfo.Address.ToString.StartsWith("127.") Then
                        ip += ipInfo.Address.ToString.PadRight(15) + vbTab
                        ip += nic.Name + vbCrLf
                    End If
                End If
            Next
        Next
        Return ip.Trim
    End Function

End Module
